;**********************************************************************
;
;	Filename:		CableChecker110.ASM
;	Date:	Version1.00	2008.12.11
;		Version1.10	2010.06.05
;				]vȃ[`폜
;	Author:		K.Kinoshita
;	Company:		Activecell.jp
;
;**********************************************************************
;
;	Files Required:	P16F886.INC
;			CableChecker110.INC
;**********************************************************************
;
;    Notes:
;
;
;
;**********************************************************************


	list	p=16f886		; list directive to define processor
	#include	<p16f886.inc>	; processor specific variable definitions
	#include	<CableChecker110.INC>

	__CONFIG	_CONFIG1, _LVP_OFF & _FCMEN_OFF & _IESO_OFF & _BOR_ON & _CPD_OFF & _CP_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_OFF & _HS_OSC
	__CONFIG	_CONFIG2, _WRT_OFF & _BOR21V

	errorlevel	-302,-306

	; external clock freq = 18.432MHz


;**********************************************************************
;*****	restart vector
;**********************************************************************
		ORG	0x000		; processor reset vector
		nop			; nop required for icd
restart		EQU	$
		clrf	PCLATH		; ensure page bits are cleared
  		goto	main		; go to beginning of program


;**********************************************************************
;*****	interrupt vector
;**********************************************************************
		ORG	0x004		; interrupt vector location
		nop
		goto	interrupt

;**********************************************************************
;*****	vZgoto
;**********************************************************************

;********************************
;*****	w ̉4rbgascii"0"`"F"ɕϊ
bin2ascii
		andlw	h'0F'
		addwf	PCL,f		; jump
		retlw	"0"
		retlw	"1"
		retlw	"2"
		retlw	"3"
		retlw	"4"
		retlw	"5"
		retlw	"6"
		retlw	"7"
		retlw	"8"
		retlw	"9"
		retlw	"A"
		retlw	"B"
		retlw	"C"
		retlw	"D"
		retlw	"E"
		retlw	"F"


;********************************
;****	Get Data
;****	block_nŎw肳ꂽԍ̃f[^̈ɃWvC
;****	byte_noCgڂ̒l w Ɋi[܂D
get_data
		movf	block_n,w		; load block number
		addwf	PCL,f		; jump

msg_OK		EQU	0
vector00		goto	block00		; OK

msg_NG		EQU	1
vector01		goto	block01		; NG

msg_CMD_ERR	EQU	2
vector02		goto	block02		; Command error

msg_PARM_ERR	EQU	3
vector03		goto	block03		; Parameter error

block00		movf	byte_n,w		; load byte number
		addwf	PCL,f		; jump
		retlw	"O"
		retlw	"K"
		retlw	0x0D
		retlw	0

block01		movf	byte_n,w		; load byte number
		addwf	PCL,f		; jump
		retlw	"N"
		retlw	"G"
		retlw	0x0D
		retlw	0

block02		movf	byte_n,w		; load byte number
		addwf	PCL,f		; jump
		retlw	"C"
		retlw	"o"
		retlw	"m"
		retlw	"m"
		retlw	"a"
		retlw	"n"
		retlw	"d"
		retlw	" "
		retlw	"e"
		retlw	"r"
		retlw	"r"
		retlw	"o"
		retlw	"r"
		retlw	0x0D
		retlw	0

block03		movf	byte_n,w		; load byte number
		addwf	PCL,f		; jump
		retlw	"P"
		retlw	"a"
		retlw	"r"
		retlw	"a"
		retlw	"m"
		retlw	"e"
		retlw	"t"
		retlw	"e"
		retlw	"r"
		retlw	" "
		retlw	"e"
		retlw	"r"
		retlw	"r"
		retlw	"o"
		retlw	"r"
		retlw	0x0D
		retlw	0

;**********************************************************************
;*****	interrupt routine
;**********************************************************************
interrupt
	; WX^̕ۑ
		movwf	w_temp		; save off current W register contents
		movf	STATUS,w		; move status register into W register
		movwf	status_temp	; save off contents of STATUS register
		movf	PCLATH,w		; move pclath register into w register
		movwf	pclath_temp	; save off contents of PCLATH register
		clrf	PCLATH		; select program memory page0
		movf	FSR,w		; store FSR in WREG
		movwf	fsr_temp		; save FSR value


	; 荞ݗṽ`FbN
	BANK0
		btfsc	PIR1,RCIF		; M荞
		bsf	STATUS,RP0	; change to bank1 if RCIF set
		btfsc	PIE1,RCIE		; test if interrupt enabled if RCIF set
		goto	GetData		; if RCIF and RCIE set, do receive

		btfsc	PIR1,TXIF		; test for TXIF transmit interrupt
		bsf	STATUS,RP0	; change to bank1 if TXIF set
		btfsc	PIE1,TXIE		; test if interrupt enabled if TXIF set
		goto	PutData		; if TXIF and TCIE set, do transmit

		btfss	PIR1,TMR1IF
		goto	int_end

	; timer1 荞(100uS)
	BANK0
		bcf	T1CON,TMR1ON	; stop tmr1
		movlw	TMR1_INITh
		movwf	TMR1H
		movlw	TMR1_INITl
		movwf	TMR1L
		bcf	PIR1,TMR1IF	; clear flag
		bsf	T1CON,TMR1ON	; start tmr1
		
		movlw	1
		subwf	timer100us,w	; decrement
		btfsc	STATUS,C
		movwf	timer100us	; store if not borrow
		goto	int_end

	; Get received data and write into receive buffer.
GetData:
	BANK0
		btfsc	RCSTA,OERR	; test overrun error flag
		goto	ErrOERR		; handle it if error
		btfsc	RCSTA,FERR	; test framing error flag
		goto	ErrFERR		; handle it if error

		btfsc	Flags,RxBufFull	; check if buffer full
		goto	ErrRxOver		; handle it if full

		movf	RCREG,W		; get received data

		xorlw	0x0d		; compare with <CR>		
		btfsc	STATUS,Z		; check if the same
		bsf	Flags,ReceivedCR	; indicate <CR> character received
		xorlw	0x0d		; change back to valid data

		xorlw	0x18		; compare with <CAN>		
		btfsc	STATUS,Z		; check if the same
		bsf	Flags,ReceivedCAN	; indicate <CAN> character received
		xorlw	0x18		; change back to valid data

		call	PutRxBuffer	; and put in buffer
		goto	int_end

	; error because OERR overrun error bit is set
	; can do special error handling here - this code simply clears and continues
ErrOERR:
		bcf	RCSTA,CREN	;reset the receiver logic
		bsf	RCSTA,CREN	;enable reception again
		goto	int_end

	; error because FERR framing error bit is set
	; can do special error handling here - this code simply clears and continues
ErrFERR:
		movf	RCREG,W		; discard received data that has error
		goto	int_end

	; error because receive buffer is full and new data has been received
	; can do special error handling here - this code simply clears and continues
ErrRxOver:
		movf	RCREG,W		; discard received data

		xorlw	0x0d		; but compare with <CR>		
		btfsc	STATUS,Z		; check if the same
		bsf	Flags,ReceivedCR	; indicate <CR> character received
		xorlw	0x0d		; change back to valid data

		xorlw	0x18		; compare with <CAN>		
		btfsc	STATUS,Z		; check if the same
		bsf	Flags,ReceivedCAN	; indicate <CAN> character received

		goto	int_end

	; Read data from the transmit buffer and transmit the data.
PutData:
	BANK0				; select bank 0
		btfss	Flags,TxBufEmpty	; check if transmit buffer empty
		goto	PutDat1		; if not then go get data and transmit
	BANK1				; select bank1
		bcf	PIE1,TXIE		; disable TX interrupt because all done
		goto	int_end

PutDat1:
		call	GetTxBuffer	; get data to transmit
		movwf	TXREG		; and transmit

	; End of interrupt routine restores context
int_end:
	BANK0
		movf	fsr_temp,w	; get saved FSR value
		movwf	FSR		; restore FSR
		movf	pclath_temp,w	; retrieve copy of PCLATH register
		movwf	PCLATH		; restore pre-isr PCLATH register contents
		movf	status_temp,w	; retrieve copy of STATUS register
		movwf	STATUS		; restore pre-isr STATUS register contents
		swapf	w_temp,f		; prepare WREG to be restored
		swapf	w_temp,w		; restore pre-isr W register contents
		retfie			; return from interrupt

;**********************************************************************
;*****	main routine
;**********************************************************************
;
main:
	BANK0
		call	init		; VXeCjVCY
		bsf	T1CON,TMR1ON	; ^C}Jn
		call	reset_vals	; ϐ̏ݒ
		call	InitGIO		; GIÕCjVCY
main_start
		bsf	INTCON,GIE	; 荞݋
		btfss	Flags,RxBufEmpty	; Mobt@ɎcĂ΃R}h`FbN
		goto	command_check	; check command
main_flash
		call	InitRxBuffer	; Mobt@NA
main_loop
		btfsc	Flags,ReceivedCR	; f~^M`FbN
		goto	command_check	; f~^o
		btfsc	Flags,ReceivedCAN	; CANLN^M`FbN
		goto	main_flash	; LZ
		goto	main_loop		; M҂[v

;********************************
; MR}h̃`FbN
command_check
		bcf	Flags,ReceivedCR	; clear flag
		call	GetRxBuffer
		btfsc	Flags,RxBufEmpty
		goto	main_loop		; Cr݂̂̏ꍇ͖

		call	ucase		; 啶ϊ
	GO_CMD	"P",p_command		; |[gANZXR}h
	GO_CMD	"S",s_command		; XLR}h
	GO_CMD	"*",i_command		; ID₢킹(*IDN?)
	GO_CMD	"N",n_command		; |[g̖₢킹
		goto	command_error	; R}hG[

;********************************
; I
command_ok
		movlw	msg_OK
		goto	command_end

;********************************
; ُI
command_ng
		movlw	msg_NG
		goto	command_end

;********************************
; R}hG[
command_error
		movlw	msg_CMD_ERR
		goto	command_end

;********************************
; p[^G[
parameter_error
		movlw	msg_PARM_ERR
		goto	command_end

;********************************
; wŎw肳ꂽbZ[W𑗐MďI
; ݂̃R}h̃f~^܂œǂݔ΂
;	w=0 : OK
;	w=1 : NG
;	w=2 : Command error
;	w=3 : Parameter error
command_end
		call	tx_mes_w			; bZ[W̑M
		goto	command_purge

;********************************
; R}ȟn
command_purge
		bcf	INTCON,GIE		; 荞݋֎~

	; f~^܂œǂݏo
command_purge_loop
		call	GetRxBuffer		; 1ǂݏo
		xorlw	0x0D
		btfsc	STATUS,Z
		goto	command_purge_end		; 
	; obt@cʃ`FbN
		btfss	Flags,RxBufEmpty		; 
		goto	command_purge_loop
command_purge_end
		bcf	INTCON,GIE		; 荞݋
		goto	main_start

;**********************************************************************
;*****	R}h

;**********************************************************************
;*****	|[g̎擾
;*****	|[gO珇Ƀ`FbNĘAAhXŎĂ|[g
;*****	̐ԂD
;
;	<>
;		N+Cr
;	<퉞>
;		pp+Cr
;		pp:[16i=00`FF]:|[g
;	<G[>
;		G[
n_command
		call	ports_count
		movwf	bin
		swapf	bin,w			; 1|[g16i2őM
		call	bin2ascii
		call	PutTxBufferWait
		movf	bin,w
		call	bin2ascii
		call	PutTxBufferWait
		movlw	0x0D
		call	PutTxBufferWait
		goto	command_purge		; I
		
;**********************************************************************
;*****	XLR}h
;@|[g00w̃|[g̊e1rbgLowɗƂCS|[g̓͏
;@ԑ
;
;	Snnii + Cr
;		nn(16i2):I|[gԍ00`FF
;		ii(16i2):C^[o00`FF(100uSP)
;	<퉞>
;		1rbgƂ̎w͈͂̑S|[g̏ԂJ}ŋ؂ĕԑ
;		rbgς邲ƂɃZ~RCCrtD
;	<G[>
;		Parameter error + Cr
;
s_command
	; p[^̓ǂݎ
		call	get2hex			; 16i2̃p[^擾
		btfsc	STATUS,C
		goto	parameter_error
		movwf	ScanMax
		call	get2hex			; 16i2̃p[^擾
		btfsc	STATUS,C
		goto	parameter_error
		movwf	ScanInterval

	; |[g̃CjVCY
		call	InitGIO
	; IODIR
		movlw	Reg_IODIR
		movwf	WRegNumber
		movlw	b'11111111'
		movwf	WData			; value
		call	SendAllGIO
	; S|[gvAbv
		movlw	Reg_GPPU
		movwf	WRegNumber
		movlw	b'11111111'		; pullup enable
		movwf	WData
		call	SendAllGIO
	; ϐ̏ݒ
		clrf	WPortAddress
		clrf	WRegNumber		; IODIR(o)
		movlw	Reg_GPIO			; GPIO(ǂݎ)
		movwf	RRegNumber

	; 1|[g̃XL[v
s_port_loop
		movlw	b'11111110'
		movwf	WData
		movlw	8
		movwf	ScanBitCounter

	; 1rbg̃XL[v
s_bit_loop
		movlw	Reg_IODIR
		movwf	WRegNumber
		call	WritePort			; GPIOWX^o
		call	delay_interval		; fBC
		clrf	RPortAddress

	; S|[g̓ǂݏoƕԑ[v
		call	WPortSave			; save write port parameters
s_read_loop
		movf	RPortAddress,w
		movwf	WPortAddress

		call	ReadPort			; ǂݏo
		swapf	RData,w			; 1|[g16i2őM
		call	bin2ascii
		call	PutTxBufferWait
		movf	RData,w
		call	bin2ascii
		call	PutTxBufferWait

	; MI`FbN
		movf	ScanMax,w
		subwf	RPortAddress,w		; w = RPortAddress - ScanMax
		btfsc	STATUS,C
		goto	s_read_end		; S|[gMI

		incf	RPortAddress,f		; ̃|[g
		movlw	","			; J}ŋ؂
		call	PutTxBufferWait
		goto	s_read_loop		; Loop
s_read_end
		call	WPortRestore		; restore write port parameters
		bsf	STATUS,C			; rbgVtg
		rlf	WData,f
		decf	ScanBitCounter,f		; 1rbgXL[vI`FbN
		btfsc	STATUS,Z
		goto	s_bit_end
s_bit_next
		movlw	";"			; Z~R
		call	PutTxBufferWait
		goto	s_bit_loop
s_bit_end
		call	WritePort			; |[go
		movf	ScanMax,w			; |[gI`FbN
		subwf	WPortAddress,w		; w = WPortAddress - ScanMax
		btfsc	STATUS,C
		goto	s_port_end
		incf	WPortAddress,f
		movlw	";"
		call	PutTxBufferWait
		goto	s_port_loop
s_port_end
		movlw	0x0D
		call	PutTxBufferWait

	; |[g̃CjVCY
		call	InitGIO
		
		goto	command_purge

;**********************************************************************
;*****	|[g̏݁Cǂݏo
;
;@|[g̏
;	PWpp,rr,dd + Cr
;		pp=00`FF:(16i2)|[gԍ
;		rr=00`FF:(16i2)WX^ԍ
;			Reg_IODIR		0x0
;			Reg_IPOL		0x1
;			Reg_GPINTEN	0x2
;			Reg_DEFVAL	0x3
;			Reg_INTCON	0x4
;			Reg_IOCON		0x5
;			Reg_GPPU		0x6
;			Reg_INTF		0x7
;			Reg_INTCAP	0x8
;			Reg_GPIO		0x9
;			Reg_OLAT		0xA
;		dd=00`FF:(16i2)f[^
;	<퉞>
;		OK + Cr
;	<G[>
;		Command error + Cr
;		Parameter error + Cr
;		NG + Cr
;
;@|[g̓ǂݏo
;	PRpp,rr + Cr
;		pp=00`FF:(16i2)|[gԍ
;			Reg_IODIR		0x0
;			Reg_IPOL		0x1
;			Reg_GPINTEN	0x2
;			Reg_DEFVAL	0x3
;			Reg_INTCON	0x4
;			Reg_IOCON		0x5
;			Reg_GPPU		0x6
;			Reg_INTF		0x7
;			Reg_INTCAP	0x8
;			Reg_GPIO		0x9
;			Reg_OLAT		0xA
;		rr=00`FF:(16i2)WX^ԍ
;	<퉞>
;	dd + Cr
;		dd=00`FF:(16i2)f[^
;	<G[>
;		Parameter error + Cr
p_command
	; Read/Write̔
		call	GetRxBuffer		; 1擾
		btfsc	Flags,RxBufEmpty
		goto	command_error
		call	ucase			; 啶

	GO_CMD	"R",pr_command			; [h
	GO_CMD	"W",pw_command			; Cg
		goto	command_error

pw_command
	; |[gԍ̓ǂݎ
		call	get2hex			; 16i2̃p[^擾
		btfsc	STATUS,C
		goto	parameter_error
		movwf	WPortAddress
	; WX^ԍ̓ǂݎ
		call	get2hex			; 16i2̃p[^擾
		btfsc	STATUS,C
		goto	parameter_error
		movwf	WRegNumber
	; ݃f[^̓ǂݎ
		call	get2hex			; 16i2̃p[^擾
		btfsc	STATUS,C
		goto	parameter_error
		movwf	WData
	; ݒ
		call	WritePort			; |[gɑ
		goto	command_ok

pr_command
	; |[gԍ̓ǂݎ
		call	get2hex			; 16i2̃p[^擾
		btfsc	STATUS,C
		goto	parameter_error
		movwf	RPortAddress
	; WX^ԍ̓ǂݎ
		call	get2hex			; 16i2̃p[^擾
		btfsc	STATUS,C
		goto	parameter_error
		movwf	RRegNumber
	; WX^̓ǂݏo
		call	ReadPort			; ǂݏo
		swapf	RData,w			; 1|[g16i2őM
		call	bin2ascii
		call	PutTxBufferWait
		movf	RData,w
		call	bin2ascii
		call	PutTxBufferWait
		movlw	0x0D
		call	PutTxBufferWait
		goto	command_purge

;**********************************************************************
;*****	ID₢킹
;	i_command
;		*IDN? + Cr
;	t@[EFAID𑗐MD
;
;	<G[>
;		Command error + Cr
i_command
		call	GetRxBuffer
		btfsc	Flags,RxBufEmpty
		goto	command_error
		call	ucase			; 啶ϊ
		sublw	"I"
		btfss	STATUS,Z
		goto	command_error
		call	GetRxBuffer
		btfsc	Flags,RxBufEmpty
		goto	command_error
		call	ucase			; 啶ϊ
		sublw	"D"
		btfss	STATUS,Z
		goto	command_error
		
		call	GetRxBuffer
		btfsc	Flags,RxBufEmpty
		goto	command_error
		call	ucase			; 啶ϊ
		sublw	"N"
		btfss	STATUS,Z
		goto	command_error

		btfsc	Flags,RxBufEmpty
		goto	i_send

		call	GetRxBuffer
		btfsc	Flags,RxBufEmpty
		goto	command_error
		call	ucase			; 啶ϊ
		sublw	"?"
		btfss	STATUS,Z
		goto	command_error

i_send

	; EEPROMIDǂݏođM
		movlw	Mes1
	BANK2
		movwf	EEADR
	BANK0

	; ̎擾
i_loop
	BANK3
		bcf	EECON1,EEPGD
	BANK3
		bsf	EECON1,RD
	BANK2
		movf	EEDATA,w
		incf	EEADR,f
	BANK0
		call	PutTxBufferWait
		sublw	0x0D
		btfss	STATUS,Z
		goto	i_loop
		goto	command_purge

;**********************************************************************
;*****	sub routines
;**********************************************************************

;**********************************************************************
;*****	AhXOAđ݂|[gwɃXgAD
;*****	ő|[gAhXw-1œD
;*****	Ă|[g݂ȂƂSTATUS.Z=1
ports_count
	; AhXXL
		clrf	WPortAddress	; address=0
		clrf	RPortAddress
		clrf	ports

		movlw	1		; Register=IPOL
		movwf	WRegNumber
		movwf	RRegNumber
ports_loop
		call	ReadPort		; IPOLWX^ǂ
		comf	RData,w		; ]
		movwf	WData		; ]lWDataɏ
		call	WritePort		; ]l𑗂
		call	ReadPort		; ēǂݏo
		movf	RData,w
		xorwf	WData,w		; r
		btfss	STATUS,Z
		goto	ports_not_exist	; ݂Ȃ
ports_exist				; ݂
		incf	ports,f		; |[gCNg
		comf	WData,f		; ]f[^߂
		call	WritePort		; 
		incf	WPortAddress,f
		incf	RPortAddress,f
		goto	ports_loop
ports_not_exist
		movf	ports,w
		return

;**********************************************************************
;*****	Mobt@2(16i2)擾āCoCiɕϊwɕԂ
;*****	G[C=1
get2hex
		call	Get1hex			; 1擾
		btfsc	Flags,RxBufEmpty
		return				; f[^Ȃ
		movwf	hex_h
		bsf	STATUS,C
		btfsc	Flags,RxBufEmpty
		return				; f[^s
		call	GetRxBuffer		; 1擾
		call	ucase			; 啶
		movwf	hex_l
		call	ascii2bin
		return				; p[^16iłȂƂC=1

;**********************************************************************
;*****	Mobt@16i܂Ŏ擾
;*****	炻̕wɃXgACC=0
;*****	ȂC=1(error)
Get1hex
		bsf	STATUS,C
		btfsc	Flags,RxBufEmpty
		return				; f[^Ȃ
		call	GetRxBuffer		; 1擾
		call	ucase			; 啶
		call	is_hex
		btfss	STATUS,C
		return				; 
		goto	Get1hex

;**********************************************************************
;*****	݃|[gp[^̃Z[u
WPortSave
		movf	WPortAddress,w
		movwf	PortAddressTemp
		movf	WRegNumber,w
		movwf	RegNumberTemp
		movf	WData,w
		movwf	PortDataTemp
		return

;**********************************************************************
;*****	݃|[gp[^̃XgA
WPortRestore
		movf	PortAddressTemp,w
		movwf	WPortAddress
		movf	RegNumberTemp,w
		movwf	WRegNumber
		movf	PortDataTemp,w
		movwf	WData
		return

;**********************************************************************
;*****	ǂݏo|[gp[^̃Z[u
RPortSave
		movf	RPortAddress,w
		movwf	PortAddressTemp
		movf	RRegNumber,w
		movwf	RegNumberTemp
		return

;**********************************************************************
;*****	ǂݏo|[gp[^̃XgA
RPortRestore
		movf	PortAddressTemp,w
		movwf	RPortAddress
		movf	RegNumberTemp,w
		movwf	RRegNumber
		return

;**********************************************************************
;*****	C^[ofBC
delay_interval
		movf	ScanInterval,w
	; continue to delay_100us
		
;**********************************************************************
;*****	100uSPʂ̃fBC
delay_100us
		movwf	timer100us
		movf	timer100us,w
		btfss	STATUS,Z
		goto	$ - 2
		return

;**********************************************************************
;*****	GIÕCjVCY
;*****	S|[g[o
InitGIO

	; IOCON
		movlw	Reg_IOCON
		movwf	WRegNumber
		movlw	b'01101000'
		movwf	WData
		call	SendAllGIO

	; GPIO
		movlw	Reg_GPIO
		movwf	WRegNumber
		movlw	b'00000000'	; zero
		movwf	WData
		call	SendAllGIO

	; IPOL
		movlw	Reg_IPOL
		movwf	WRegNumber
		movlw	b'00000000'
		movwf	WData
		call	SendAllGIO

	; GPINTEN
		movlw	Reg_GPINTEN
		movwf	WRegNumber
		movlw	b'00000000'
		movwf	WData
		call	SendAllGIO

	; DEFVAL
		movlw	Reg_DEFVAL
		movwf	WRegNumber
		movlw	b'00000000'
		movwf	WData
		call	SendAllGIO

	; INTCON
		movlw	Reg_INTCON
		movwf	WRegNumber
		movlw	b'00000000'
		movwf	WData
		call	SendAllGIO

	; IODIR
		movlw	Reg_IODIR
		movwf	WRegNumber
		movlw	b'00000000'	; output
		movwf	WData
		call	SendAllGIO

	; GPPU
		movlw	Reg_GPPU
		movwf	WRegNumber
		movlw	b'11111111'	; enable
		movwf	WData
		call	SendAllGIO

		return

;**********************************************************************
;*****	SẴ|[gPortAddressWData𑗂
SendAllGIO
		movlw	MaxAddress
		movwf	WPortAddress
SendAllGIO_loop
		call	WritePort
		movlw	1
		subwf	WPortAddress,f
		btfsc	STATUS,C		; skip if borrow
		goto	SendAllGIO_loop
		return

;**********************************************************************
;	wGIO|[gSPIf[^
; PortAddress:	|[gAhX
;	00`0F:VXe{[h(i0,1,2,3̂)
;	10`1F:g{[h1
;	20`2F:g{[h2
; RegNumber:	WX^ԍ
;	Reg_IODIR		0x0
;	Reg_IPOL		0x1
;	Reg_GPINTEN	0x2
;	Reg_DEFVAL	0x3
;	Reg_INTCON	0x4
;	Reg_IOCON		0x5
;	Reg_GPPU		0x6
;	Reg_INTF		0x7
;	Reg_INTCAP	0x8
;	Reg_GPIO		0x9
;	Reg_OLAT		0xA
; WData:	݃f[^
;
WritePort
	; ^[QbgGIOCSLowɉ
		call	WCStoLow			; YGIO`bvCSLowɉ
	; OpCodȇM
		movf	SSPBUF,w			; Dummy read
		bcf	SSPCON,WCOL		; reset COL flag
		bcf	PIR1,SSPIF		; reset SSPIF
		movf	WPortAddress,w
		andlw	b'00001110'		; chip address and write mode
		iorlw	b'01000000'		; set device code
		movwf	SSPBUF
		btfss	PIR1,SSPIF		
		goto	$ - 1
	; Register Address̑M
		bcf	SSPCON,WCOL
		bcf	PIR1,SSPIF
		bcf	STATUS,C
		rlf	WRegNumber,w
		btfsc	WPortAddress,0
		iorlw	b'00000001'		; set BPORT
		movwf	SSPBUF
		btfss	PIR1,SSPIF		
		goto	$ - 1
	; DatȃM
		bcf	SSPCON,WCOL
		bcf	PIR1,SSPIF
		movf	WData,w
		movwf	SSPBUF
		btfss	PIR1,SSPIF		
		goto	$ - 1

		call	CStoHigh			; CSHighɖ߂
		return

;**********************************************************************
;	wGIO|[g̃WX^ǂݏo
; RPortAddress:	|[gAhX
;	00`07:VXe{[h
;	08`2F:g{[h
; RRegNumber:	WX^ԍ
;	Reg_IODIR		0x0
;	Reg_IPOL		0x1
;	Reg_GPINTEN	0x2
;	Reg_DEFVAL	0x3
;	Reg_INTCON	0x4
;	Reg_IOCON		0x5
;	Reg_GPPU		0x6
;	Reg_INTF		0x7
;	Reg_INTCAP	0x8
;	Reg_GPIO		0x9
;	Reg_OLAT		0xA
; RData:	ǂݏof[^
;
ReadPort
	; ^[QbgGIOCSLowɉ
		call	RCStoLow			; YGIO`bvCSLowɉ
	; OpCodȇM
		movf	SSPBUF,w			; Dummy read
		bcf	SSPCON,WCOL		; reset COL flag
		bcf	PIR1,SSPIF		; reset SSPIF
		bcf	STATUS,C
		movf	RPortAddress,w
		andlw	b'00001110'		; chip address
		iorlw	b'01000001'		; set device code and read mode
		movwf	SSPBUF
		btfss	PIR1,SSPIF		
		goto	$ - 1
	; Register Address̑M
		bcf	SSPCON,WCOL
		bcf	PIR1,SSPIF
		bcf	STATUS,C
		rlf	RRegNumber,w
		btfsc	RPortAddress,0
		iorlw	b'00000001'		; set BPORT
		movwf	SSPBUF
		btfss	PIR1,SSPIF		
		goto	$ - 1
	; Data̎M
		bcf	SSPCON,WCOL
		bcf	PIR1,SSPIF
		movlw	0
		movwf	SSPBUF
		btfss	PIR1,SSPIF		
		goto	$ - 1
		movf	SSPBUF,w
		movwf	RData

		call	CStoHigh			; CSHighɖ߂
		return

;**********************************************************************
;	w(RPortAddress)ɑΉGIO`bvCSLowɉ
RCStoLow
		call	CStoHigh
		movf	RPortAddress,w
		sublw	0x0F			; w = 0x0F - RPortAddress
		btfsc	STATUS,C
		goto	CStoLow0

		movf	RPortAddress,w
		sublw	0x1F			; w = 0x1F - RPortAddress
		btfsc	STATUS,C
		goto	CStoLow1
		goto	CStoLow2

;**********************************************************************
;	w(WPortAddress)ɑΉGIO`bvCSLowɉ
WCStoLow
		call	CStoHigh
		movf	WPortAddress,w
		sublw	0x0F			; w = 0x0F - WPortAddress
		btfsc	STATUS,C
		goto	CStoLow0

		movf	WPortAddress,w
		sublw	0x1F			; w = 0x1F - WPortAddress
		btfsc	STATUS,C
		goto	CStoLow1
CStoLow2		
		bcf	PORTC,nXCS2
		return
CStoLow1		
		bcf	PORTC,nXCS1
		return
CStoLow0		
		bcf	PORTC,nCS
		return

;**********************************************************************
;	ׂĂGIO`bvCSHighɏグ
CStoHigh
		bsf	PORTC,nCS
		bsf	PORTC,nXCS1
		bsf	PORTC,nXCS2
		return

;**********************************************************************
;*****	R0`R26BCD̒lasciiɕϊđMobt@ɃXgA
;*****	ʂ̃[̓TvXD
;PutTxBCD
		bsf	Flags,ZeroSuppress		; set suppress bit
		swapf	R0,w
		call	bin2ascii
		call	PutTx1BCD
		movf	R0,w
		call	bin2ascii
		call	PutTx1BCD

		swapf	R1,w
		call	bin2ascii
		call	PutTx1BCD
		movf	R1,w
		call	bin2ascii
		call	PutTx1BCD

		swapf	R2,w
		call	bin2ascii
		call	PutTx1BCD
		movf	R2,w
		call	bin2ascii
		call	PutTx1BCD
		return
		
;**********************************************************************
;*****	w<>"0"ȂFlags.ZeroSuppress=0
;*****	Flags.ZeroSuppress0Ȃw̓e𑗐Mobt@̍Ōɉ
PutTx1BCD
		xorlw	"0"
		btfss	STATUS,Z
		bcf	Flags,ZeroSuppress
		xorlw	"0"
		btfss	Flags,ZeroSuppress
		call	PutTxBufferWait
		return

;**********************************************************************
;*****	w̓e𑗐Mobt@̍Ōɉ
;*****	w̓e͕ۑ
;*****	Mobt@t̎͑ҋ@
PutTxBufferWait:
		btfsc	Flags,TxBufFull	;  check if buffer full
		goto	$ - 1
	; continue to PutTxBuffer

;**********************************************************************
;*****	w̓e𑗐Mobt@̍Ōɉ
;*****	w̓e͕ۑ
PutTxBuffer:
	BANK1
		bcf	PIE1,TXIE		;  disable transmit interrupt
	BANK0
		btfsc	Flags,TxBufFull	;  check if buffer full
		goto	ErrTxBufFull	;  and go handle error if full

	BANKISEL		TxBuffer		; bank bit for indirect addressing
		movwf	BufferData	; save WREG data into BufferData
		movf	TxEndPtr,W	; get EndPointer
		movwf	FSR		; and place into FSR
		movf	BufferData,W	; get BufferData
		movwf	INDF		; and store in buffer

	; test if buffer pointer needs to wrap around to beginning of buffer memory
		movlw	LOW TxBuffer+TX_BUF_LEN-1	; get last address of buffer
		xorwf	TxEndPtr,W	; and compare with end pointer
		movlw	LOW TxBuffer	; load first address of buffer
		btfss	STATUS,Z		; check if pointer is at last address
		incf	TxEndPtr,W	; if not then increment pointer
		movwf	TxEndPtr		; store new end pointer value

	; test if buffer is full
		subwf	TxStartPtr,W	; compare with start pointer
		btfsc	STATUS,Z		; check if the same
		bsf	Flags,TxBufFull	; if so then indicate buffer full
		bcf	Flags,TxBufEmpty	; buffer cannot be empty
	BANK1
		bsf	PIE1,TXIE		; enable transmit interrupt
	BANK0
		movf	BufferData,w	; restore data
		return

	; error because attempting to store new data and the buffer is full
	; can do special error handling here - this code simply ignores the byte
ErrTxBufFull:
	BANK1
		bsf	PIE1,TXIE		; enable transmit interrupt
	BANK0
		return 			; no save of data because buffer full

;**********************************************************************
;*****	w̓eMobt@̍Ōɉ
;*****	w̓e͕ۑ
PutRxBuffer:
	BANK0
		btfsc	Flags,RxBufFull	; check if buffer full
		goto	ErrRxBufFull	; and go handle error if full

	BANKISEL		RxBuffer		; bank bit for indirect addressing
		movwf	BufferData	; save WREG into BufferData
		movf	RxEndPtr,W	; get EndPointer
		movwf	FSR		; and place into FSR
		movf	BufferData,W	; get BufferData
		movwf	INDF		; store in buffer

	; test if buffer pointer needs to wrap around to beginning of buffer memory
		movlw	LOW RxBuffer+RX_BUF_LEN-1	; get last address of buffer
		xorwf	RxEndPtr,W	; and compare with end pointer
		movlw	LOW RxBuffer	; load first address of buffer
		btfss	STATUS,Z		; check if pointer is at last address
		incf	RxEndPtr,W	; if not then increment pointer
		movwf	RxEndPtr		; store new end pointer value

	; test if buffer is full
		subwf	RxStartPtr,W	; compare with start pointer
		btfsc	STATUS,Z		; check if the same
		bsf	Flags,RxBufFull	; if so then indicate buffer full
		bcf	Flags,RxBufEmpty	; buffer cannot be empty
		movf	BufferData,w	; restore data
		return

	; error because attempting to store new data and the buffer is full
	; can do special error handling here - this code simply ignores the byte
ErrRxBufFull:
		return 			; no save of data because buffer full

;**********************************************************************
;*****	Mobt@̍ŏ̃oCgwɎ擾č폜
GetTxBuffer:
	BANK0
		btfsc	Flags,TxBufEmpty	; check if transmit buffer empty
		goto	ErrTxBufEmpty	; and go handle error if empty

	BANKISEL		TxBuffer		; bank bit for indirect addressing
		movf	TxStartPtr,W	; get StartPointer
		movwf	FSR		; and place into FSR

	; test if buffer pointer needs to wrap around to beginning of buffer memory
		movlw	LOW TxBuffer+TX_BUF_LEN-1	; get last address of buffer
		xorwf	TxStartPtr,W	; and compare with start pointer
		movlw	LOW TxBuffer	; load first address of buffer
		btfss	STATUS,Z		; check if pointer is at last address
		incf	TxStartPtr,W	; if not then increment pointer
		movwf	TxStartPtr	; store new pointer value
		bcf	Flags,TxBufFull	; buffer cannot be full

	; test if buffer is now empty
		xorwf	TxEndPtr,W	; compare start to end	
		btfsc	STATUS,Z		; check if the same
		bsf	Flags,TxBufEmpty	; if same then buffer will be empty
		movf	INDF,W		; get data from buffer

		return

	; error because attempting to read data from an empty buffer
	; can do special error handling here - this code simply returns zero
ErrTxBufEmpty:	return			; tried to read empty buffer

;**********************************************************************
;*****	Mobt@̍ŏ̃oCgwɎ擾č폜
GetRxBuffer:
	BANK0
		btfsc	Flags,RxBufEmpty	; check if receive buffer empty
		goto	ErrRxBufEmpty	; and go handle error if empty
	BANK1
		bcf	PIE1,RCIE		; disable receive interrupt
	BANK0
	BANKISEL		RxBuffer		; bank bit for indirect addressing
		movf	RxStartPtr,W	; get StartPointer
		movwf	FSR		; and place into FSR

	; test if buffer pointer needs to wrap around to beginning of buffer memory
		movlw	LOW RxBuffer+RX_BUF_LEN-1	; get last address of buffer
		xorwf	RxStartPtr,W	;  and compare with start pointer
		movlw	LOW RxBuffer	; load first address of buffer
		btfss	STATUS,Z		; check if pointer is at last address
		incf	RxStartPtr,W	; if not then increment pointer
		movwf	RxStartPtr	; store new pointer value
		bcf	Flags,RxBufFull	; buffer cannot be full

	; test if buffer is now empty
		xorwf	RxEndPtr,W	; compare start to end	
		btfsc	STATUS,Z		; check if the same
		bsf	Flags,RxBufEmpty	; if same then buffer will be empty
		movf	INDF,W		; get data from buffer
	BANK1
		bsf	PIE1,RCIE		; enable receive interrupt
	BANK0
		return

	; error because attempting to read data from an empty buffer
	; can do special error handling here - this code simply returns zero
ErrRxBufEmpty:
	BANK1
		bsf	PIE1,RCIE		; enable receive interrupt
	BANK0
		return			; tried to read empty buffer

;**********************************************************************
;*****	wp̎͑啶ɕϊ
;	͉̑̎Ȃ
ucase
		movwf	ucase_temp
		movlw	"a"
		subwf	ucase_temp,w		; w =  ucase_temp - "a"
		btfss	STATUS,C
		goto	ucase_end			; "a"
		movf	ucase_temp,w
		sublw	"z"			; w = "z" - ucase_temp
		btfss	STATUS,C
		goto	ucase_end			; "z"
	; ϊ
		movlw	0x20
		subwf	ucase_temp,w
		return
ucase_end
		movf	ucase_temp,w
		return
		
		
;**********************************************************************
;*****	16i hex_h, hex_l oCi w,bin ɕϊ
;*****	ꂩ16iłȂC=1,w,bin=0
ascii2bin
		clrf	bin
		movf	hex_h,w
		call	is_hex
		movlw	0
		btfsc	STATUS,C
		return			; 16ił͂Ȃ

		movf	hex_l,w
		call	is_hex
		movlw	0
		btfsc	STATUS,C
		return			; 16ił͂Ȃ

	; asciioCilɕϊ
		movlw	"9" + 1
		subwf	hex_h,f
		movlw	-7
		btfsc	STATUS,C
		addwf	hex_h,f
		movlw	.10
		addwf	hex_h,f

		movlw	"9" + 1
		subwf	hex_l,f
		movlw	-7
		btfsc	STATUS,C
		addwf	hex_l,f
		movlw	.10
		addwf	hex_l,f

	; 1oCgɍ
		swapf	hex_h,w
		iorwf	hex_l,w
		movwf	bin
		bcf	STATUS,C		; no error
		return

;**********************************************************************
;*****	w 16iȂC=0
;*****	w ͕ωȂ
is_hex
		movwf	is_temp		; save
	; "0"̓G[
		movlw	"0"
		subwf	is_temp,w	;  w = is_temp - "0"
		btfss	STATUS,C
		goto	is_hex_no		; < "0" if borrow
	; "9"ȉ16i
		movf	is_temp,w
		sublw	"9"		; w = "9" - is_temp
		btfsc	STATUS,C
		goto	is_hex_yes	; <= "9"
	; "A"̓G[
		movlw	"A"
		subwf	is_temp,w	;  w = is_temp - "A"
		btfss	STATUS,C
		goto	is_hex_no		; < "A" if borrow
	; "F"ȉ16i
		movf	is_temp,w
		sublw	"F"		; w = "F" - is_temp
		btfsc	STATUS,C
		goto	is_hex_yes	; <= "F"
	; "a"̓G[
		movlw	"a"
		subwf	is_temp,w	;  w = is_temp - "a"
		btfss	STATUS,C
		goto	is_hex_no		; < "a" if borrow
	; "f"ȉ16i
		movf	is_temp,w
		sublw	"f"		; w = "f" - is_temp
		btfsc	STATUS,C
		goto	is_hex_yes	; <= "f"
is_hex_no
		movf	is_temp,w
		bsf	STATUS,C		; 16iłȂ̂܂܂Ă
		return
		
is_hex_yes
		movf	is_temp,w
		bcf	STATUS,C		; 16i
		return

;**********************************************************************
;*****	w ̓eɂChrFlags̃rbgZbg
;*****	w ͕ωȂ
ChrCheck
		movwf	Chr_temp		; save
		clrf	ChrFlags		; reset flag
	; Cr
		xorlw	0x0D
		btfsc	STATUS,Z
		goto	Chr_Delim
		xorlw	0x0D
	; Lf
		xorlw	0x0A
		btfsc	STATUS,Z
		goto	Chr_Delim
		xorlw	0x0A
	; ,
		xorlw	","
		btfsc	STATUS,Z
		goto	Chr_Delim
		xorlw	","
	; :
		xorlw	";"
		btfsc	STATUS,Z
		goto	Chr_Delim
		xorlw	";"
	; .
		xorlw	"."
		btfsc	STATUS,Z
		goto	Chr_Dot
		xorlw	"."
	; 0`9
	; "0"͂̑
		movlw	"0"
		subwf	Chr_temp,w	;  w = Chr_temp - "0"
		btfss	STATUS,C
		goto	Chr_Other		; < "0" if borrow
	; "9"ȉȂ琔(16i܂)
		movf	Chr_temp,w
		sublw	"9"		; w = "9" - Chr_temp
		btfsc	STATUS,C
		goto	Chr_Num		; <= "9"
	; 16i
	; "A"͂̑
		movlw	"A"
		subwf	Chr_temp,w	; w = Chr_temp - "A"
		btfss	STATUS,C
		goto	Chr_Other		; < "A" if borrow
	; "F"ȉ16i
		movf	Chr_temp,w
		sublw	"F"		; w = "F" - Chr_temp
		btfsc	STATUS,C
		goto	Chr_Hex		; <= "F"
	; "a"͂̑
		movlw	"a"
		subwf	Chr_temp,w	;  w = Chr_temp - "a"
		btfss	STATUS,C
		goto	Chr_Other		; < "a" if borrow
	; "f"ȉ16i
		movf	is_temp,w
		sublw	"f"		; w = "f" - Chr_temp
		btfsc	STATUS,C
		goto	Chr_Hex		; <= "f"
Chr_Other
		movf	Chr_temp,w
		clrf	ChrFlags
		return
Chr_Delim
		movf	Chr_temp,w
		bsf	ChrFlags,ChrDelimiter
		return
Chr_Dot
		movf	Chr_temp,w
		bsf	ChrFlags,ChrDot
		return
Chr_Num
		movf	Chr_temp,w
		bsf	ChrFlags,ChrNum
		return
Chr_Hex
		movf	Chr_temp,w
		bsf	ChrFlags,ChrHex
		return

;**********************************************************************
;*****	VA|[gMi^CAEgtj
rec_next
		movlw	0xE9
		movwf	TMR1H
		movlw	0x7F
		movwf	TMR1L		; 10mS
		bcf	PIR1,TMR1IF
		bsf	T1CON,TMR1ON
rec_next_wait
		btfsc	PIR1,RCIF		; MWX^̃`FbN
		goto	rec_next_get
		btfss	PIR1,TMR1IF
		goto	rec_next_wait
rec_next_timeout
		bsf	STATUS,C		; ^CAEg
		return
rec_next_get
		movf	RCREG,w
		bcf	STATUS,C
		return

;**********************************************************************
;*****	w Ŏw肳f[^ubNԍ̕𑗐MD
tx_mes_w	
		movwf	block_n
		; continue to tx_mes

;**********************************************************************
;*****	block_n Ŏw肳f[^ubNԍ̕𑗐MD
tx_mes	
		clrf	byte_n		; clear byte pointer
tx_mes1
		call	get_data		; get data
		movwf	mes_temp		; save data
		movf	mes_temp,w	; restore data
		btfsc	STATUS,Z
		goto	tx_mes_end
		call	PutTxBufferWait
		incf	byte_n,f		; increment byte pointer
		goto	tx_mes1
tx_mes_end
		return


;**********************************************************************
;*****	ϐ̃Zbg
reset_vals
		movlw	b'00001010'
		movwf	Flags
		call	ports_count	; |[g̎擾
		movwf	MaxAddress
		btfss	STATUS,Z
		decf	MaxAddress,f	; AhXɒ
		return
	
;**********************************************************************
;*****	initialize
;	VXeCjVCY
init:
	; CjVCY͊荞݋֎~
		clrf	INTCON

	; NbNݒ

	; |[gݒ
	BANKSEL		PORTA
		movlw	PA_INIT		; PortA set init data
		movwf	PORTA
		movlw	PB_INIT		; PortB set init data
		movwf	PORTB
		movlw	PC_INIT		; PortC set init data
		movwf	PORTC
		movlw	PE_INIT		; PortE set init data
		movwf	PORTE

	; |[gfBNV̐ݒ
	BANKSEL		TRISA
		movlw	PA_DIREC
		movwf	TRISA
		movlw	PB_DIREC
		movwf	TRISB
		movlw	PC_DIREC
		movwf	TRISC
		movlw	PE_DIREC
		movwf	TRISE

	; OPTION_REG̐ݒ
	BANKSEL		OPTION_REG
		movlw	b'10000100'	; pullup disable, divide 32
		movwf	OPTION_REG

	; ADϊW[̏ݒ
	BANKSEL		ANSELH
		clrf	ANSELH	; All DIO
		clrf	ANSEL	; All DIO

	; |[gĐݒ
	BANKSEL		PORTA
		movlw	aPA_INIT		; PortA set init data
		movwf	PORTA
		movlw	aPB_INIT		; PortB set init data
		movwf	PORTB
		movlw	aPC_INIT		; PortC set init data
		movwf	PORTC
		movlw	aPE_INIT		; PortE set init data
		movwf	PORTE

	; |[gfBNV̍Đݒ
	BANKSEL		TRISA
		movlw	aPA_DIREC
		movwf	TRISA
		movlw	aPB_DIREC
		movwf	TRISB
		movlw	aPC_DIREC
		movwf	TRISC
		movlw	aPE_DIREC
		movwf	TRISE

	; TMR1̐ݒ
	; 1mS荞݃^C}
	BANKSEL		T1CON
		movlw	b'00000100'		; presc = 1:1
		movwf	T1CON
		movlw	TMR1_INITh
		movwf	TMR1H
		movlw	TMR1_INITl
		movwf	TMR1L

	; TMR2̐ݒ
	; gp

	; PWM̐ݒ
	; gp

	; SPI̐ݒ
	BANKSEL		SSPSTAT
		movlw	b'01000000'
		movwf	SSPSTAT
	BANKSEL		SSPCON
		movlw	b'00100000'
		movwf	SSPCON

	; USART̐ݒ
	BANKSEL		TXSTA
		movlw	b'00100100'
		movwf	TXSTA
		movlw	BPS_DEFAULT
		movwf	SPBRG
	BANKSEL		RCSTA
		movlw	b'10010000'
		movwf	RCSTA
	BANKSEL		BAUDCTL
		movlw	b'00000000'
		movwf	BAUDCTL
	BANK0
		call	InitTxBuffer	;initialize transmit buffer
		call	InitRxBuffer	;initialize receive buffer

	; 荞ݐݒ
	BANKSEL		PIR1
		movlw	b'00000000'
		movwf	PIR1
	BANKSEL		PIE1
		movlw	b'00110001'
		movwf	PIE1

	; INTCON ̐ݒ
	BANKSEL		TMR0
		clrf	TMR0
	BANKSEL		INTCON
		movlw	b'01000000'
		movwf	INTCON

	BANK0

		return


;**********************************************************************
;*****	Initialize transmit buffer
InitTxBuffer:
	BANK0
		movlw	LOW TxBuffer	; take address of transmit buffer
		movwf	TxStartPtr	; and place in transmit start pointer
		movwf	TxEndPtr		; and place in transmit end pointer
		bcf	Flags,TxBufFull	; indicate Tx buffer is not full
		bsf	Flags,TxBufEmpty	; indicate Tx buffer is empty
		return

;**********************************************************************
;*****	Initialize receive buffer
InitRxBuffer:
	BANK0
		movlw	LOW RxBuffer	; take address of receive buffer
		movwf	RxStartPtr	; and place in receive start pointer
		movwf	RxEndPtr		; and place in receive end pointer
		bcf	Flags,RxBufFull	; indicate Rx buffer is not full
		bsf	Flags,RxBufEmpty	; indicate Rx buffer is empty
		bcf	Flags,ReceivedCR
		bcf	Flags,ReceivedCAN
		return

	END                       ; directive 'end of program'

