;**********************************************************************
;*****	Declare EEPROM Data Byte
;**********************************************************************
		ORG	0x2100
Mes1		EQU	$ - 0x2100
			;01234567890123456789
		DE	"Cable checker Version1.10",0x0D,0

;**********************************************************************
;*****	MACRO definitions
;**********************************************************************

; oNؑ
BANK0		macro
		bcf	STATUS,RP0
		bcf	STATUS,RP1
		bcf	STATUS,IRP
		endm

BANK1		macro
		bsf	STATUS,RP0
		bcf	STATUS,RP1
		bcf	STATUS,IRP
		endm

BANK2		macro
		bcf	STATUS,RP0
		bsf	STATUS,RP1
		bsf	STATUS,IRP
		endm

BANK3		macro
		bsf	STATUS,RP0
		bsf	STATUS,RP1
		bsf	STATUS,IRP
		endm

; R}h
GO_CMD		macro	CHARACTER,COMMAND_ADDR
		xorlw	CHARACTER		; Compare
		btfsc	STATUS,Z
		goto	COMMAND_ADDR	; Match
		xorlw	CHARACTER		; Restore
		endm


;**********************************************************************
;*****	PORT bit assign
;**********************************************************************

;*****	PORTA
; bit assign
; Initial Data/Direction
PA_INIT		EQU	b'00000000'	; Initial Data
PA_DIREC		EQU	b'10000000'	; Direction
aPA_INIT		EQU	b'00000000'
aPA_DIREC		EQU	b'10000000'

;*****	PORTB
; bit assign
; Initial Data/Direction
PB_INIT		EQU	b'00000000'	; Initial Data
PB_DIREC		EQU	b'00000000'	; Direction
aPB_INIT		EQU	b'00000000'	; First Data on operation 
aPB_DIREC		EQU	b'00000000'	; Direction on operation

;*****	PORTC
; bit assign
nCS		EQU	0		; Chip select out (active Low)
nXCS1		EQU	1		; Extend CS1 out
nXCS2		EQU	2		; Extend CS2 out
TXD		EQU	6		; Tx data out
RXD		EQU	7		; Rx data in
; Initial Data/Direction
PC_INIT		EQU	b'11000111'	; Initial Data
PC_DIREC		EQU	b'10010000'	; Direction
aPC_INIT		EQU	b'11000111'	; First Data on operation 
aPC_DIREC		EQU	b'10010000'	; Direction on operation

;*****	PORTE
	; bit assign
	; Initial Data/Direction
PE_INIT		EQU	b'11111111'	; Initial Data
PE_DIREC		EQU	b'11111111'	; Direction
aPE_INIT		EQU	b'11111111'	; First Data on operation 
aPE_DIREC		EQU	b'11111111'	; Direction on operation

;**********************************************************************
;*****	Constants definitions
;**********************************************************************

;*****	ʐMx	external clock freq = 18.432MHz
;	ʐMxɑΉSPBRG̐ݒl(BRGH=1)
BPS_9600		EQU	0x77
BPS_14400		EQU	0x4F
BPS_19200		EQU	0x3B
BPS_38400		EQU	0x1D
BPS_57600		EQU	0x13
BPS_115200	EQU	0x09
BPS_230400	EQU	0x04

BPS_DEFAULT	EQU	BPS_115200	; Deafult

;*****	TMR1vZbgl
TMR1_INITh	EQU	0xFE		; 100uSԊů荞
TMR1_INITl	EQU	0x54

;*****	M
TX_BUF_LEN	EQU	.50		; length of transmit circular buffer
RX_BUF_LEN	EQU	TX_BUF_LEN	; length of receive circular buffer

;**********************************************************************
;*****	Resister number
Reg_IODIR		EQU	0x0
Reg_IPOL		EQU	0x1
Reg_GPINTEN	EQU	0x2
Reg_DEFVAL	EQU	0x3
Reg_INTCON	EQU	0x4
Reg_IOCON		EQU	0x5
Reg_GPPU		EQU	0x6
Reg_INTF		EQU	0x7
Reg_INTCAP	EQU	0x8
Reg_GPIO		EQU	0x9
Reg_OLAT		EQU	0xA

;**********************************************************************
;*****	Flags Bit Definitions
;**********************************************************************
TxBufFull		EQU	0		; bit indicates Tx buffer is full
TxBufEmpty	EQU	1		; bit indicates Tx buffer is empty
RxBufFull		EQU	2		; bit indicates Rx buffer is full
RxBufEmpty	EQU	3		; bit indicates Rx buffer is empty
ReceivedCR	EQU	4		; bit indicates <CR> character received
ReceivedCAN	EQU	5		; bit indicates <CAN> character received
ZeroSuppress	EQU	6		; suppress flag

;**********************************************************************
;*****	ChrFlags Bit Definitions
;**********************************************************************
ChrSpace		EQU	0		; Xy[X
ChrDelimiter	EQU	1		; Cr,Lf,J}CZ~R̂ꂩ
ChrDot		EQU	2		; hbg
ChrNum		EQU	3		; 0`9
ChrHex		EQU	4		; 16i

;**********************************************************************
;*****	Variable definitions
;**********************************************************************

	; variable used for context saving
	CBLOCK	0x71
		w_temp
		status_temp
		pc_temp
		pclath_temp
		fsr_temp
	ENDC

	; variables BANK0
	CBLOCK	0x21
		mes_temp			; Z[up
		block_n			; bZ[W̃ubNԍ
		byte_n			; bZ[W̕ԍ
		hex_h
		hex_l
		is_temp
		Chr_temp
		bin
		ports			; |[g

		bb_temp1			; bin - bcd
		bb_temp2
		H_byte			; binary high
		L_byte			; binary low
		R0			; bcd high
		R1			; bcd mid
		R2			; bcd low

		ucase_temp
		ChrFlags			; `FbNtO

		Flags			; byte to store indicator flags
		BufferData		; temporary data in buffer routines 
		TxStartPtr		; pointer to start of data in TX buffer
		TxEndPtr			; pointer to end of data in TX buffer
		RxStartPtr		; pointer to start of data in RX buffer
		RxEndPtr			; pointer to end of data in RX buffer

		; GIO8rbg̉z|[gƂď
		MaxAddress
		WPortAddress		; write port address
		RPortAddress		; read port address
					;  00 to 07 : on board
					;  08 to 2F : extend board
		WRegNumber		; write register number
		RRegNumber		; read register number
					;  0:IODIR
					;  1:IPOL
					;  2:GPINTEN
					;  3:DEFVAL
					;  4:INTCON
					;  5:IOCON
					;  6:GPPU
					;  7:INTF
					;  8:INTCAP
					;  9:GPIO
					;  A:OLAT
		WData			; write data
		RData			; read data
		PortAddressTemp
		RegNumberTemp
		PortDataTemp
		
		SourceBit_h
		SourceBit_l
		DestBit_h
		DestBit_l

		ScanMax			; XLR}h̍ő|[gԍ
		ScanPort			; ݂̃|[gԍ
		ScanInterval		; XLԊԊu(100uSP)
		ScanBitCounter		; 8rbgJE^
		
		timer100us		; 100uSԊũJEg_E^C}



	ENDC

	; variables BANK3
	CBLOCK	0x190
		TxBuffer:TX_BUF_LEN	; transmit data buffer
		RxBuffer:RX_BUF_LEN	; receive data buffer
	ENDC
